    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025     * Other names may be trademarks of their respective owners.]
    026     *
    027     * --------------------
    028     * DrawingSupplier.java
    029     * --------------------
    030     * (C) Copyright 2003-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 16-Jan-2003 : Version 1 (DG);
    038     * 17-Jan-2003 : Renamed PaintSupplier --> DrawingSupplier (DG);
    039     * ------------- JFREECHART 1.0.x ---------------------------------------------
    040     * 13-Jun-2007 : Added getNextOutlinePaint() method.
    041     *
    042     */
    043
    044    package org.jfree.chart.plot;
    045
    046    import java.awt.Paint;
    047    import java.awt.Shape;
    048    import java.awt.Stroke;
    049
    050    /**
    051     * A supplier of <code>Paint</code>, <code>Stroke</code> and <code>Shape</code>
    052     * objects for use by plots and renderers.  By providing a central place for
    053     * obtaining these items, we can ensure that duplication is avoided.
    054     * <p>
    055     * To support the cloning of charts, classes that implement this interface
    056     * should also implement <code>PublicCloneable</code>.
    057     */
    058    public interface DrawingSupplier {
    059
    060        /**
    061         * Returns the next paint in a sequence maintained by the supplier.
    062         *
    063         * @return The paint.
    064         */
    065        public Paint getNextPaint();
    066
    067        /**
    068         * Returns the next outline paint in a sequence maintained by the supplier.
    069         *
    070         * @return The paint.
    071         */
    072        public Paint getNextOutlinePaint();
    073
    074        /**
    075         * Returns the next fill paint in a sequence maintained by the supplier.
    076         *
    077         * @return The paint.
    078         *
    079         * @since 1.0.6
    080         */
    081        public Paint getNextFillPaint();
    082
    083        /**
    084         * Returns the next <code>Stroke</code> object in a sequence maintained by
    085         * the supplier.
    086         *
    087         * @return The stroke.
    088         */
    089        public Stroke getNextStroke();
    090
    091        /**
    092         * Returns the next <code>Stroke</code> object in a sequence maintained by
    093         * the supplier.
    094         *
    095         * @return The stroke.
    096         */
    097        public Stroke getNextOutlineStroke();
    098
    099        /**
    100         * Returns the next <code>Shape</code> object in a sequence maintained by
    101         * the supplier.
    102         *
    103         * @return The shape.
    104         */
    105        public Shape getNextShape();
    106
    107    }